<template>
    <span>{{isUseLangres ? $t(text) : text}}</span>
</template>

<script lang="ts">
import { Vue, Component, Prop,Watch,Model } from 'vue-property-decorator';
import CodeListService from "@service/app/codelist-service";

@Component({})
export default class DropDownList extends Vue {
    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof AppSpan
     */  
    public codeListService:CodeListService = new CodeListService({ $store: this.$store });

    /**
     * 当前值
     * 
     * @type {*}
     * @memberof AppSpan
     */
    @Prop() public data?: any;


    /**
     * 监控表单属性 data 值
     *
     * @memberof AppSpan
     */
    @Watch('data')
    onDataChange(newVal: any, oldVal: any) {
        if(newVal !== oldVal){
           this.load();
        }
    }

    /**
     * 显示值
     * @type {*}
     * @memberof AppSpan
     */
    public text:any = '';

    /**
     * 编辑器类型
     *
     * @type {string}
     * @memberof AppSpan
     */
    @Prop() public editorType?: string;

    /**
     * 代码表标识
     *
     * @type {string}
     * @memberof AppSpan
     */
    @Prop() public tag?: string;

    /**
     * 代码表类型
     *
     * @type {string}
     * @memberof AppSpan
     */
    @Prop() public codelistType?: string;

    /**
     * 代码表
     *
     * @type {any[]}
     * @memberof AppSpan
     */
    public items: any[] = [];

    /**
     * vue  生命周期
     *
     * @memberof AppSpan
     */
    public created() {
        this.load();
    }

    /**
     * 是否使用多语言资源
     * @type {boolean}
     * @memberof AppSpan
     */
    public isUseLangres:boolean = false;

    /**
     * 加载代码表
     * 
     * @memberof AppSpan
     */
    public load(){
        if(Object.is(this.editorType,'PICTURE') || Object.is(this.editorType,'PICTURE_ONE') ||Object.is(this.editorType,'FILEUPLOADER')){
            let files: any[] = JSON.parse(this.data);
            let names: any[] = [];
            files.forEach((item:any) => {
                names.push(item.name);
            });
            this.text = names.join(',');
        }else{
            if(this.tag && Object.is(this.codelistType,"STATIC")){
                const codelist = this.$store.getters.getCodeList(this.tag);
                if (codelist) {
                    this.items = [...JSON.parse(JSON.stringify(codelist.items))];
                    this.setText();
                } else {
                    console.log(`----${this.tag}----代码表不存在`);
                }
            }else if(this.tag && Object.is(this.codelistType,"DYNAMIC")){
                this.codeListService.getItems(this.tag).then((res:any) => {
                    this.items = res;
                    this.setText();
                }).catch((error:any) => {
                    console.log(`----${this.tag}----代码表不存在`);
                });
            }else{
                this.setText();
            }
        }
    }

    /**
     * 设置显示值
     * @memberof AppSpan
     */
    public setText(){
      this.isUseLangres = false;
      if(this.items.length>0){
          let currentItem:any = this.items.find((item:any)=>{
              return item.value == this.data;
          });
          if(currentItem){
              if(Object.is(this.codelistType,'STATIC')){
                  this.isUseLangres = true;
                  this.text = 'codelist.'+this.tag+'.'+this.data;
              }else{
                  this.text = currentItem.label;
              }
          }else{
              this.isUseLangres = true;
              this.text = 'codelist.'+this.tag+'.empty';
          }
      }else{
          this.text = this.data;
      }
    }
    
}
</script>

<style lang='less'>
@import './app-span.less';
</style>